﻿using UnityEngine;
using XLua;

public class Events : MonoBehaviour {
    private int _clickCount = 0;
    private int _menuMode = 1;

	// Use this for initialization
	void Start () {
        AbyssLibU_XLua.Instance.DoScript("Lua/LTI");
        AbyssLibU_XLua.Instance.DoScript(System.Environment.CurrentDirectory + "\\LuaTest.lua.txt");
        AbyssLibU_XLua.Instance.Call("MakeMenu3");
    }
	
	// Update is called once per frame
	void Update () {
	}

    //背景をクリック
    public void BG_OnClick()
    {
        GameObject.Find("Menu").transform.position = new Vector3(2000, 0);
        GameObject.Find("Menu2").transform.position = new Vector3(2000, 0);
        if (GameObject.Find("Menu3") != null)
        {
            GameObject.Find("Menu3").transform.position = new Vector3(2000, 0);
        }
    }

    //背景を右クリック
    public void BG_OnRightClick()
    {
        switch (_menuMode)
        {
            case (1):
                GameObject.Find("Menu").transform.position = Input.mousePosition;
                break;
            case (2):
                GameObject.Find("Menu2").transform.position = Input.mousePosition;
                break;
            case (3):
                GameObject.Find("Menu3").transform.position = Input.mousePosition;
                break;
        }
    }

    //モード変更ボタンをクリック
    public void onClick_Mode()
    {
        _menuMode = (++_menuMode == 4) ? 1 : _menuMode;
        GameObject.Find("Mode").GetComponentInChildren<UnityEngine.UI.Text>().text = "Mode" + _menuMode.ToString();
    }

    //追加ボタンの挙動
    public void onClick_Generated_Button()
    {
        Debug.Log("じぇねれいてっどぼたん！！！（" + _menuMode.ToString() + "）（" + _clickCount++.ToString() + "）（" + System.DateTime.Now.ToString() + "）");
    }

    //Menuのボタンをクリック
    public void OnClick_Button()
    {
        Debug.Log("Buttonがクリックされました（" + _menuMode.ToString() + "）（" + _clickCount++.ToString() + "）（" + System.DateTime.Now.ToString() + "）");
        UnityEngine.UI.Button NewButton = Instantiate(Resources.Load<UnityEngine.UI.Button>("Prefabs/Button"));
        NewButton.transform.SetParent(GameObject.Find("Menu").transform);
        NewButton.GetComponentInChildren<UnityEngine.UI.Text>().text = "Generated Button1";
        NewButton.onClick.AddListener(onClick_Generated_Button);
        //レイアウトを強制更新
        UnityEngine.UI.LayoutRebuilder.ForceRebuildLayoutImmediate(GameObject.Find("Menu").GetComponent<UnityEngine.RectTransform>());
    }

    //Menu2のボタンをクリック
    public void OnClick_Button2()
    {
        Debug.Log("Buttonがクリックされました（" + _menuMode.ToString() + "）（" + _clickCount++.ToString() + "）（" + System.DateTime.Now.ToString() + "）");
        UnityEngine.UI.Button NewButton = Instantiate(Resources.Load<UnityEngine.UI.Button>("Prefabs/Button"));
        NewButton.transform.SetParent(GameObject.Find("Menu2").transform.Find("Viewport/Content").gameObject.transform);
        NewButton.GetComponentInChildren<UnityEngine.UI.Text>().text = "Generated Button2";
        NewButton.onClick.AddListener(onClick_Generated_Button);
        //レイアウトを強制更新
        UnityEngine.UI.LayoutRebuilder.ForceRebuildLayoutImmediate(GameObject.Find("Menu2").transform.Find("Viewport/Content").GetComponent<UnityEngine.RectTransform>());
    }

}
